/********************************************************************
Name :			Mahmood Khaleefah Awadh Salim al-jadidi ..
ID Number :		86621 ..
Collage :		Collage Of Science ..
Major :			Computer Sience ..

************************************************

Program Definition ..

This Program Reads Customer ID "Represented As A String" Of Three Characters Together With The
Three Purchases In Rials He/She Made During The Week. The Program Then Compute The Total
Purchase For Each Customer And Assign The Appropriate Group Category To The Customer.

********************************************************************/

# include < iostream >
# include < iomanip >
# include < fstream >
# include < string >
using namespace std;


/**************************************
		Function's Prototypes ..
**************************************/

float FindTotal( float , float , float );
string FindGroup ( float );
void PrintInfo ( string , float , float , float , float , string );


int main ()
{


/**************************************
		Declaration ..
**************************************/

	string ID,Group;
	float TotalValue,V1,V2,V3;

	ifstream InData;										// In Data File ..



/**************************************
		Opening File ..
**************************************/

	InData.open("pvalues.dat.txt");


/**************************************
		Display The Hade ..
**************************************/


	cout << setw(13) << left << "Customer" << setw(9) << left << "V1" << setw(9) << left << "V2"
		 << setw(9) << left << "V3" << setw(9) << left << "Total" << setw(20) << "Group" << endl;


/**************************************
		Do While Statment ..
**************************************/

	InData >> ID >> V1 >> V2 >> V3;
	while ( InData )
	{
		TotalValue = FindTotal ( V1 , V2 , V3 );
		Group = FindGroup ( TotalValue );
		PrintInfo ( ID , V1 , V2 , V3 , TotalValue , Group );


/**************************************
		Reading Data ..
**************************************/

		InData >> ID >> V1 >> V2 >> V3;

	}

	cout << endl << endl ;


/**************************************
		End Program ..
**************************************/

	return 0;

}


/**************************************
		FindTotal Function ..
**************************************/


float FindTotal ( float V1 , float V2 , float V3 )
{
	return ( V1 + V2 + V3 );

}

/**************************************
		FindGroup Function ..
**************************************/

string FindGroup ( float TotalValue )
{

	if ( TotalValue > 150 )
	{
		return" Gold";
	}

	else if ( TotalValue > 100 && TotalValue < 150 )
	{
		return "Silver";
	}

	else if ( TotalValue > 50 && TotalValue < 100)
	{
		return "Bronze";
	}

	else
	{
		return "Nothing";
	}

}

/**************************************
		PrintInfo Function ..
**************************************/

void PrintInfo ( string ID , float V1 , float V2 , float V3 , float TotalValue , string Group )
{

	cout << setw(13) << left << ID << setw(9) << left << V1 << setw(9) << left << V2 << setw(9)
		<< left << V3 << setw(9) << left << TotalValue << setw(20) << Group << endl;


}