/***************************************************************************
Name	:
ID		:
Major	:		Department of Computer Science
College	:		Collage Of Science
****************************************************

This Program Is Developed A Simple Data And File Management System Of A Simple Employee Information ..
This Program Does 5 Main Tasks :

(1) Display The Menu Of Options ..
(2) Find An Employee Data ..
(3) Add A New Employee Data ..
(4) Delete An Employee Data ..
(5) Print Final Updata Report In File ..

***************************************************************************/

# include < iostream >
# include < iomanip >
# include < fstream >
# include < string >
using namespace std;

/**************************************
		Structur's Decleration ..
**************************************/

struct Employee
{
	int ID;									// Employee's ID ..
	string Name;							// Employee's Name ..
	string Gender;							// Employee's Gender ..
	float Salary;							// Employee's Salary ..
};

/**************************************
		Function's Prototypes ..
**************************************/

void DisplayMenu ( );						// Display Menu Function ..
void FindEmp ( );							// Find Employee Function ..
void AddEmp ( );							// Add Employee Function ..
void DeleteEmp ( );							// Delete Employee Function ..
void StopPrint ( Employee[] );				// Stop Print Function ..
bool SearchData ( int );					// Call Find Employee Function ..

/**************************************
		Global Variabls ..
**************************************/

int Option,i,ID,count;
Employee EMP[5];							// Structure Array ..


/**************************************
		Main Function ..
**************************************/

int main ()
{

	ifstream InData;						// Declare InPut File ..
	InData.open("EmpInput.txt");			// Open InPut File ..

/**************************************
		Check If File is Openning ..
**************************************/

	if ( ! InData )
	{
		cout << " Erorr, Can Not Open The File .." << endl << endl ;			// Error Masseage ..

		return 0;
	}

/**************************************
		Reading File ..
**************************************/

	count = 0;
	i = 1;

	while ( InData )						// Reading Data By Looping ..
	{

		InData >> EMP[i].ID >> EMP[i].Name >> EMP[i].Gender >> EMP[i].Salary;

		count++;							// Counter ..
		i++;
	}

	DisplayMenu ( );						// Call DisplayMenu Function ..

	while ( Option >= 1 && Option <= 3 )
	{

		if ( Option == 1 )
		{
			FindEmp ( );					// Call Find Employee Function ..
		}

		else if ( Option == 2 )
		{
			AddEmp ( );						// Call Add Employee Function ..
		}

		else
		{
			DeleteEmp ( );					// Call Delete Employee Function ..
		}

		DisplayMenu ( );					// Call DisplayMenu Function ..

	}

	StopPrint ( EMP );						// Call StopPrint Function ..

	return 0;
}


/**************************************
		Display Menu Function Definition ..
**************************************/

void DisplayMenu ( )
{
	Option = 0;
	while ( Option < 1 || Option > 4 )
	{
		cout << "*** EMPLOYEE INFORMATION SYSTEM ***" << endl;
		cout << "  **  EL-BAHR COMPANY RUSYL  **" << endl << endl;
		cout << "(1) Find Employee Data .." << endl;
		cout << "(2) Add New Employee Data .." << endl;
		cout << "(3) Delete Employee Data .." << endl;
		cout << "(4) Stop and Print the Report .." << endl << endl;
		cout << "- Enter Your Option :  ";
		cin >> Option;
		cout << endl;

		if ( Option < 1 || Option > 4 )
		{
			cout << "- Please, Enter One Of The options Only ..";		// Error Masseage ..
			cout << endl << endl;
		}
	}

};


/**************************************
		Find Employee Function Definition ..
**************************************/

void FindEmp ( )
{

	cout << "- Enter The ID :  ";
	cin >> ID;
	cout << endl;


	SearchData ( ID );						// Search About ID ..

	if ( SearchData ( ID ) )
	{
		i = ID;
		cout << setw(30) << left << "* Employee Id:" << EMP[i].ID << endl;
		cout << setw(30) << left << "* First Name: " << EMP[i].Name << endl;
		cout << setw(30) << left << "* Gender:" << EMP[i].Gender << endl;
		cout << setw(30) << left << "* Salary:" << EMP[i].Salary << endl << endl;

	}

	else
	{
		cout << endl;
		cout << "- Sorry, Can Not Find This ID .." << endl << endl;		// Error Masseage ..
	}
}


/**************************************
		Add Employee Function Definition ..
**************************************/

void AddEmp ( )

{
	cout << "- Enter The ID :  ";
	cin >> ID;
	SearchData ( ID );						// Search About ID ..

	if ( SearchData ( ID ) )
	{

		cout << endl;
		cout << "*** Error *** " << endl;						// Error Masseage ..
		cout << "- The Employee Already Exists" << endl << endl;
		cout << "- Enter '1' To Provide Another ID , Or '0' To Go To The Main Menu: ";
		cin >> Option;
		cout << endl << endl;

		if ( Option == 1 )
		{
			AddEmp ( );						// Call Add Employee Function ..
		}

		else
		{

			DisplayMenu ( );				// Call DisplayMenu Function ..
		}
	}

	else
	{
		cout << endl;
		cout << "- Enter Employee Id:		";			// Add ID ..
		cin >> EMP[i].ID;
		cout << "- Enter First Name:		";			// Add Name ..
		cin >> EMP[i].Name;
		cout << "- Enter Gender:			";			// Add Gender ..
		cin >> EMP[i].Gender;		
		cout << "- Enter Salary:			";			// Add Salary ..
		cin >> EMP[i].Salary;

		cout << endl;

	}
}

/**************************************
		Delete Employee Function Definition ..
**************************************/

void DeleteEmp ( )
{
	cout << "- Enter The ID :  ";
	cin >> ID;

	SearchData ( ID );						// Search About ID ..

	if ( SearchData ( ID ) )
	{
		EMP[i].ID = 0;

		cout << endl;
		cout << "- Employee ID Found And Deleted .. " << endl << endl;
	}

	else
	{
		cout << "- Sorry, Can Not Find This ID .." << endl << endl;			// Error Masseage ..
	}

}

/**************************************
		Stop Print Employee Function Definition ..
**************************************/

void StopPrint ( Employee[] )
{

	ofstream OutData;						// Declare OutPut File ..
	OutData.open("EmpOutput.txt");			// Open OutPut File ..

	cout << "- Thank You .." << endl;
	cout << "- Updated Employee Data Has Be Saved As A Final Report In Out Data File .." << endl << endl;

/**************************************
		Save Out Data Information In The File ..
**************************************/

	OutData << "- Thank You .." << endl;
	OutData << "- Here Is The Final Report On Student Data .." << endl << endl;
	OutData << setw(15) << left << "Empl.ID" << setw(15) << left << "First Name" <<
		setw(15) << left << "Gender" << "Salare" << endl;


/**************************************
		DisPlay Results ..
**************************************/

	i = 1;
	while ( i < count )
	{
 
		if ( EMP[i].ID != 0 )
		{
			OutData << fixed << showpoint <<setprecision(2);
			OutData << setw(15) << left << EMP[i].ID << setw(15) << left << EMP[i].Name <<
			setw(15) << left << EMP[i].Gender << EMP[i].Salary << endl;
		}


		i++;

	}
}

/**************************************
		Search Data Employee Function Definition ..
**************************************/

bool SearchData ( int ID )
{

	for ( i = 1 ; i<=5 ; i++ )
	{

		if ( ID == EMP[i].ID )
		{
			return true;
		}

	}

	return false;

}